<?php

/**
 * The public-facing functionality of the plugin.
 *
 * @link       https://AmorStyle
 * @since      1.0.0
 *
 * @package    tweb2price
 * @subpackage tweb2price/public
 */

define('TABLE_RNAME_TWEB2PRICE','tweb2price');

/*
This class should take an ID and return a database record pertaining to the card.
*/
class tweb2price_record
{
	private $record = array(); // what is in the database
	
	// On creation, we set the visibiity and perform the search to set the list.	
	public function __construct()
	{
		self::get(1);
	}
			
	public function create_table() 
	{
		global $wpdb;

		//$wpdb->show_errors();
	
		$table_name = $wpdb->prefix . TABLE_RNAME_TWEB2PRICE; 
		
		$charset_collate = $wpdb->get_charset_collate();

		$sql = "CREATE TABLE $table_name (
			id int(11) NOT NULL AUTO_INCREMENT,	
			lasttime int(32) NOT NULL,
			json text(4096) NOT NULL,
			
			UNIQUE KEY id (id)
		) $charset_collate;";
		
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );
	
		//$wpdb->hide_errors();
		//$wpdb->print_error();
		return $wpdb->insert_id;	
	}
	public function delete_table()
	{
		global $wpdb;

		//$wpdb->show_errors();

		$table_name = $wpdb->prefix . TABLE_RNAME_TWEB2PRICE;

		delete_option($table_name);

		// drop a custom database table
		$wpdb->query("DROP TABLE IF EXISTS {$table_name}");

		//$wpdb->hide_errors();
		//$wpdb->print_error();
	}

	public function get($id)
	{
		global $wpdb;

		//$wpdb->show_errors();

		$table_name = $wpdb->prefix . TABLE_RNAME_TWEB2PRICE; // something like: wpas_tweb2price
		$Ret = NULL;

		$lookup="SELECT * FROM `".$table_name."` where id='".$id."'";
			
		$metadata = $wpdb->get_results($lookup);
		if( sizeof($metadata) > 0 )
		{
			//echo "READ "; var_dump($metadata); echo " END<br>";
			$this->record = $metadata; // save the array
			return true;
		}
		
		//$wpdb->hide_errors();
		//$wpdb->print_error();
		return false;
	}


	//
	// Writes a record to the database.
	// timestamp
	// response as json text
	//
	public function update( $id, $curtime, $json ) 
	{
		global $wpdb;
		$Ret = false;
		$table_name = $wpdb->prefix . TABLE_RNAME_TWEB2PRICE;

		//$wpdb->show_errors();

		$lookup="SELECT * FROM `".$table_name."` where id='".$id."'";
		//echo $lookup."<br>";

		$args = array(	"id" => $id,
						"lasttime" => $curtime, 
						"json" => $json);
			
		$metadata = $wpdb->get_results($lookup);
		if( sizeof($metadata) > 1 )
		{
			// Only expect to find our row in the database!
			return $Ret;
		}
		else if( sizeof($metadata) > 0 )
		{
			// note that this routine returns false if the record that we're writing is the same as the record in the database.
			$Ret = $wpdb->update(
				$table_name, 	#The name of the database table
				$args,
				array( 'id' => $metadata[0]->id )
			);
			//echo "found and updated! setting id to: ".$metadata[0]->id.", Ret=".$Ret."<br>";
		}
		else
		{
			// * else the option did not exist, add it to the database.
			$wpdb->insert($table_name,$args);
			$Ret = $wpdb->insert_id;
		}

		//$wpdb->hide_errors();
		//$wpdb->print_error();
		return $Ret;
	}

	public function id()
	{
		if( !empty($this->record))
		{
			return $this->record[0]->id;
		}
		return 0;
	}

	public function lasttime()
	{
		if( !empty($this->record))
		{
			return $this->record[0]->lasttime;
		}
		return 0;
	}

	public function json()
	{
		if( !empty($this->record))
		{
			return $this->record[0]->json;
		}
		return NULL;
	}
	
}
function tweb2price_record()
{
	$tweb2price_record=new tweb2price_record();
	return $tweb2price_record;
}
